<?php

// We now look at the changes table to see what has changed on the clients database, then communicate any changes to Glide
include_once("db.php");	// Our database connection code - with correct username/password

// This is your Glide API key - you can find it at https://www.whatsglide.com/i/ams_sysconfig.php#glideapi
$gkey = "c4d8e196d529d34e477175a36f1cee9810a3026d3a631b9a13b2fb1720c24087";

// Firstly mark all those changes that we are going to deal with this time
$sql = "UPDATE changes SET done = 1 WHERE done = 0";
try { $result = D::i()->query($sql); } catch(PDOException $e) { $error = 1; echo "Error"; echo $e->getMessage(); }

// Now move through all of those that we are going to deal with on this run
$sql = "SELECT * FROM changes WHERE done = 1";
try { $result = D::i()->query($sql); } catch(PDOException $e) { $error = 1; echo "Error"; echo $e->getMessage(); }

while($row = $result->fetch())
{
	// Deal with each change
	if($row['changetype'] == 'NEW') // We have a new client
	{
		// Read data about the client from the clients database
		$sql2 = "SELECT * FROM clients WHERE id = '".$row['client']."' LIMIT 1";
		try { $result2 = D::i()->query($sql2); } catch(PDOException $e) { $error = 1; echo "Error"; echo $e->getMessage(); }
		
		while($row2 = $result2->fetch())
		{
			// Use Glide API to create a new client
			$command = "/clients/create";				// The API command that we will be using
			$baseurl = "http://api.whatsglide.com";		// Create the request URL
			$url = $baseurl.$command."?key=".$gkey."&returnFormat=1";	// Build the URL that we will call

			$ch = curl_init();									// Initiate curl
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); 	// Disable SSL verification
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_URL,$url);					// Set the url that we wish to call

			// Now we build up a PHP array with the data for our new client - these are some of the fields that we can supply
			$fields = array();
			$fields['name'] = urlencode($row2['name']);
			$fields['type'] = "1";
			$fields['ucode'] = urlencode($row2['code']);
			$fields['opt_incorpdate'] = urlencode($row2['incorp']);

			// Note: You might wish to expand upon this to include other fields, see documentation for all posibilities
			
			// Turn the above array into a string that we can pass as POST fields
			$fields_string = "";
			foreach($fields as $key=>$value) { $fields_string .= $key.'='.$value.'&'; }
			$fields_string = rtrim($fields_string, '&');
			curl_setopt($ch,CURLOPT_POST, count($fields));			// Set the cURL options for POST data
			curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);

			$curl_result = curl_exec($ch);			// Execute our request (call Glide and make our request)
			curl_close($ch);		// Close down cURL - as we have done what we wished to do

			$array_result = array();	// PHP array to place our decoded data into
			$array_result = (array)json_decode($curl_result, true);

			print_r($array_result);		// For now we will just print out what we have gotten back from Glide

			// Now - some data is stored in 'Additional Client Fields', we run additional API calls for this data
						
			// In our example the phone number is stored in a special client field, so we run a seperate API call for that
			// You would repeat this for other fields
			$clientID = $row2['code']; 			// This is the unique client code that you specified at creation
			$fieldID = "220";					// This the database field code for 'Phone 1'
			$value = urlencode($row2['phone']); // This is the data to insert into the field, note we need to use urlencode

			$command = "/clients_by_id2/$clientID/set/$fieldID/$value";				// The API command that we will be using

			$baseurl = "http://api.whatsglide.com";		// Create the request URL
			$url = $baseurl.$command."?key=".$gkey."&returnFormat=1";	// Build the URL that we will call
			
			$ch2 = curl_init();									// Initiate curl
			curl_setopt($ch2, CURLOPT_SSL_VERIFYPEER, false); 	// Disable SSL verification
			curl_setopt($ch2, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch2, CURLOPT_URL,$url);					// Set the url that we wish to call
			curl_setopt($ch2, CURLOPT_HTTPGET, 1);
			
			$curl_result = curl_exec($ch2);			// Execute our request (call Glide and make our request)
			curl_close($ch2);		// Close down cURL - as we have done what we wished to do

			$array_result = array();	// PHP array to place our decoded data into
			$array_result = (array)json_decode($curl_result, true);

			print_r($array_result);		// For now we will just print out what we have gotten back from Glide
		}
	}
	else if($row['changetype'] == 'EDIT') // Edit a client
	{
		// Read data about the client from the clients database
		$sql2 = "SELECT * FROM clients WHERE id = '".$row['client']."' LIMIT 1";
		try { $result2 = D::i()->query($sql2); } catch(PDOException $e) { $error = 1; echo "Error"; echo $e->getMessage(); }
		
		while($row2 = $result2->fetch())
		{
			$clientID = $row2['code']; 			// This is the unique client code that you specified at creation

			$command = "/clients_by_id2/update";				// The API command that we will be using
			$baseurl = "http://api.whatsglide.com";		// Create the request URL
			$url = $baseurl.$command."?key=".$gkey."&returnFormat=1";	// Build the URL that we will call

			$ch = curl_init();									// Initiate curl
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); 	// Disable SSL verification
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_URL,$url);					// Set the url that we wish to call

			// Now we build up a PHP array with the data for our new client - these are the fields that we will supply
			// Note: You may wish to supply more or less data, see the documentation for full details
			$fields = array();
			$fields['name'] = urlencode($row2['name']);
			$fields['ucode'] = urlencode($row2['code']);
			$fields['opt_incorpdate'] = urlencode($row2['incorp']);
			
			// Turn the above array into a string that we can pass as POST fields
			$fields_string = "";
			foreach($fields as $key=>$value) { $fields_string .= $key.'='.$value.'&'; }
			$fields_string = rtrim($fields_string, '&');
			curl_setopt($ch,CURLOPT_POST, count($fields));			// Set the cURL options for POST data
			curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);

			$curl_result = curl_exec($ch);			// Execute our request (call Glide and make our request)
			curl_close($ch);		// Close down cURL - as we have done what we wished to do

			$array_result = array();	// PHP array to place our decoded data into
			$array_result = (array)json_decode($curl_result, true);

			print_r($array_result);		// For now we will just print out what we have gotten back from Glide

		
			// The phone number is stored in a special client field, so we run a seperate API call for that
			$fieldID = "220";					// This the database field code
			$value = urlencode($row2['phone']); // This is the data to insert into the field, note we need to use urlencode

			$command = "/clients_by_id2/$clientID/set/$fieldID/$value";				// The API command that we will be using

			$baseurl = "http://api.whatsglide.com";		// Create the request URL
			$url = $baseurl.$command."?key=".$gkey."&returnFormat=1";	// Build the URL that we will call

			$ch2 = curl_init();									// Initiate curl
			curl_setopt($ch2, CURLOPT_SSL_VERIFYPEER, false); 	// Disable SSL verification
			curl_setopt($ch2, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch2, CURLOPT_URL,$url);					// Set the url that we wish to call
			curl_setopt($ch2, CURLOPT_HTTPGET, 1);

			$curl_result = curl_exec($ch2);			// Execute our request (call Glide and make our request)
			curl_close($ch2);		// Close down cURL - as we have done what we wished to do

			$array_result = array();	// PHP array to place our decoded data into
			$array_result = (array)json_decode($curl_result, true);

			print_r($array_result);		// For now we will just print out what we have gotten back from Glide
		}
	}
}

// Now finally set all of the change records that we were dealing with to done
$sql = "UPDATE changes SET done = 2 WHERE done = 1";
try { $result = D::i()->query($sql); } catch(PDOException $e) { $error = 1; echo "Error"; echo $e->getMessage(); }

?>